Bug 40716 - JK 1.2.19 on IIS6: Worker reference doesn't work
JK 1.2.19 on IIS6: Worker reference doesn't work
Status: CLOSED FIXED
Product: Tomcat Connectors
Classification: Unclassified
Component: Common
unspecified
PC Windows Server 2003
: P2 normal (vote)
: ---
Assigned To: Tomcat Developers Mailing List
:
Depends on:
Blocks:
  Show dependency tree
 
Reported: 2006-10-10 07:43 UTC by Bjoern Andersen
Modified: 2008-10-05 03:09 UTC (History)
0 users



Attachments
My isapi_redirect.properties (699 bytes, text/plain)
2006-10-10 07:46 UTC, Bjoern Andersen
Details
My workers.properties (4.24 KB, text/plain)
2006-10-10 07:49 UTC, Bjoern Andersen
Details
Log file in debug Mode (9.69 KB, text/plain)
2006-10-10 08:01 UTC, Bjoern Andersen
Details
Adding the reference feature to IIS and Netscape (1.40 KB, patch)
2006-10-10 19:08 UTC, Rainer Jung
Details | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Bjoern Andersen 2006-10-10 07:43:28 UTC
The new feature of JK1.2.19:
-reference- This directive allows to copy configurations ...
doesn't seem to work. I tried several configurations, different names for my 
workers, with or without "worker." - prefix. The workers won't inherit the 
properties of my template-worker.
Comment 1 Bjoern Andersen 2006-10-10 07:46:06 UTC
Created attachment 18982 [details]
My isapi_redirect.properties

The config is done here, not in the registry.
Comment 2 Bjoern Andersen 2006-10-10 07:49:06 UTC
Created attachment 18983 [details]
My workers.properties

As you can see, i've been experimenting a lot with our 6-node-cluster. nothing
worked. Now nearly all is commented out, so that only 2 TCs are working. Still
no inheritance. The settings from worker "template" won't appear in the jk
manager.
Comment 3 Bjoern Andersen 2006-10-10 07:53:01 UTC
Uriworkermap.properties consists only of 4 lines:

/myweb.mydomain.de*/herstportal/*.jsp=LBPTomHH
/myweb.mydomain.de*/herstportal/*.do=LBPTomHH
/myweb.mydomain.de*/herstportal/*.servlet=LBPTomHH
/myweb.mydomain.de*/jkmanager=jkstatus

no magic.
Btw, all works fine if I define the settings in the workers directly.
So I got a workaround. But we also got much bigger clusters, so a function 
like "reference" would realy come in handy.
Comment 4 Bjoern Andersen 2006-10-10 08:01:39 UTC
Created attachment 18984 [details]
Log file in debug Mode

Here the log in debug mode, with just one request to jkmanager.
Comment 5 Mladen Turk 2006-10-10 08:10:05 UTC
Don't know why it doesn't work.

Anyhow you have some errors in the workers.propeties
worker.template.connect_timeout=90
worker.template.reply_timeout=900

Remember that those values are in miliseconds (unlike other
timeouts that are in seconds).

I think I'll add a simple rule:
(if timeout < 1000 then timeout = timeout * 1000)

Having timeouts smaller then 1 second is insane anyhow, and
this would help deling with obvious typos like this.
Comment 6 Jeff Johnson 2006-10-10 08:31:50 UTC
I had in the past used timeouts of 500 milliseconds so that if a server was
un-responsive jk would fail over to another server very quickly without the
customer waiting.  Half a second doesn't seem that short when our average page
time delivered back to the customer across the internet is only 330 milliseconds.
Comment 7 Bjoern Andersen 2006-10-10 08:38:53 UTC
Of cause Mladen Turk is right, i misread the configuration there. Set it to 
5000 onthe connect timeout and 900000 on the reply timeout (yes, we have some 
verry long running servlets).
Jeff Johnson might have a point there, but we got a multitier environment with 
database and mainframe-backends. so no way in answering in that time.

Nevertheless, nice comments, but the reported bug is still there, even with 
the new more sane values.
Comment 8 Jeff Johnson 2006-10-10 08:58:06 UTC
I agree that the reply_timeout below 1000 is aggressive but the connect_timeout
and prepost_timeout (ping/pong) below a second seems very reasonable. 
Especially when running a cluster that doesn't need sessions.  

If tomcat can't say that its alive in less than a second, something is probably
wrong with it.  IIRC we used to have this problem when our garbage collection
wasn't tuned well.

Regarding the reference problem, I almost reported a bug yesterday saying that
reference didn't work but I had forgot the "worker." prefix (which I see that
you tried).  As soon as I fixed that, my workers did indeed inherit the lbfactor
setting so I know it works at least for that in my case.
Comment 9 Rainer Jung 2006-10-10 09:53:02 UTC
You are right. The reference feature is missing for non-Apache webservers.
We'll clarify the docs and add it to the other webservers.

Thank you for your observation and sorry for any inconvenience.
Comment 10 Rainer Jung 2006-10-10 19:08:19 UTC
Created attachment 18986 [details]
Adding the reference feature to IIS and Netscape

You might want to try this patch, since the next release will not be available
soon.
Comment 11 Rainer Jung 2006-10-10 19:32:55 UTC
The feature will work for IIS and Netscape to, sarting in 1.2.20. Since that
version will not be released soon, you might want to try the attached patch for
1.2.19.

The docs have been updated with a warning.
Comment 12 Rainer Jung 2008-01-01 16:51:28 UTC
Move a couple of fixed JK issues from resolved to closed.